;**********************************************************
;*               Ex1.ASM
;*  This program is for edit test, the program also display
;*  a delay results on the LEDs on PORTC. 
;*  Please make sure that the DIP switch SW3 has all 
;*  switches in the ON position.
;**********************************************************
		list p=16F877A		
#include 	<p16f877A.inc>		; Include file locate at defult directory
;
VAL_US		equ	.160			; 1ms delay valum
VAL_MS		equ	.100
Count		equ	0x20			; Defined temp reg. for 1ms delay
Count_ms	equ	0x21            ; Defined delay reg.
;
;***************************************
;           Program start              *
;***************************************
			org 	0x00		; reset vector
			nop					; Reserve for MPLAB-ICD
Initial:	
			clrw				; W =0
			clrf	PCLATH 		
			banksel	TRISD		; Select to bank1
			clrf 	TRISD		; PORTC = Output
			banksel PORTD 		; Select to bank0
			clrf	PORTD		; Clear PORTC
;
;************ Main *********************
;
_start:
			incf	PORTD,f		; PORTD = PORTD + 1
			call 	_delay_100ms	; Call delay routine
			goto	_start
;
;-------- 100 ms delay routine ----------
_delay_100ms:
			movlw	VAL_MS		 
			movwf	Count_ms
_loop_ms	call 	_delay_1ms
			decfsz	Count_ms,f
			goto	_loop_ms
			return
;
;-------- 1 ms delay routine -----------
_delay_1ms:	 
			movlw	VAL_US		 		
			movwf	Count
_dec_loop	call 	_D_short
			decfsz	Count,f
			goto 	_dec_loop
			return
;
;--------     Delay 5uS    -------------
_D_short	call	_D_ret				; 1uS * 4 + 1uS = 10uS
			call	_D_ret
			call	_D_ret
			call	_D_ret
			nop
			nop
_D_ret		return	
;	
			end
